import Alert from '@opentiny/vue-alert';
import Button from '@opentiny/vue-button';
import Modal from '@opentiny/vue-modal';
import FileUpload from '@opentiny/vue-file-upload';
import Progress from '@opentiny/vue-progress';
import Popconfirm from '@opentiny/vue-popconfirm';
import { renderless, api } from '@opentiny/vue-renderless/pop-upload/vue';
import { defineComponent, props, setup } from '@opentiny/vue-common';
import { resolveComponent, openBlock, createElementBlock, createVNode, withCtx, createTextVNode, toDisplayString, createElementVNode, renderSlot, Fragment, createBlock, renderList, createCommentVNode, withDirectives, normalizeClass, vShow } from 'vue';

function _createForOfIteratorHelperLoose(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (t) return (t = t.call(r)).next.bind(t);
  if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) {
    t && (r = t);
    var o = 0;
    return function() {
      return o >= r.length ? { done: true } : { done: false, value: r[o++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}
function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  components: {
    TinyButton: Button,
    TinyModal: Modal,
    TinyAlert: Alert,
    TinyFileUpload: FileUpload,
    TinyProgress: Progress,
    TinyPopconfirm: Popconfirm
  },
  props: [].concat(props, ["data", "uploadName", "httpRequest", "beforeUpload", "beforeRemove", "size", "dialogTitle", "uploadButtonText", "withCredentials", "submitButtonText", "cancelButtonText", "uploadFileType", "maxUploadFileSize", "accept", "disabled", "multiple", "limit", "headers", "action", "fileList"]),
  emits: ["remove", "progress", "error", "exceed", "success"],
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1 = {
  class: "tiny-popupload"
};
var _hoisted_2 = {
  class: "tiny-popupload__dialog"
};
var _hoisted_3 = {
  class: "tiny-popupload__dialog-header"
};
var _hoisted_4 = {
  class: "tiny-popupload__dialog-tips"
};
var _hoisted_5 = {
  class: "tiny-popupload__dialog-tips"
};
var _hoisted_6 = {
  class: "tiny-popupload__dialog-tips"
};
var _hoisted_7 = {
  class: "tiny-popupload__dialog-body"
};
var _hoisted_8 = {
  class: "tiny-popupload__dialog-table"
};
var _hoisted_9 = {
  class: "tiny-popupload__dialog-table-header"
};
var _hoisted_10 = {
  class: "header-col col1"
};
var _hoisted_11 = {
  class: "header-col col2"
};
var _hoisted_12 = {
  class: "header-col col3"
};
var _hoisted_13 = {
  class: "header-col col4"
};
var _hoisted_14 = {
  class: "tiny-popupload__dialog-table-body"
};
var _hoisted_15 = {
  class: "tiny-popupload__dialog-table-list"
};
var _hoisted_16 = {
  class: "body-col col1"
};
var _hoisted_17 = {
  class: "body-col col2"
};
var _hoisted_18 = {
  class: "body-col col3"
};
var _hoisted_19 = {
  key: 0
};
var _hoisted_20 = {
  key: 2
};
var _hoisted_21 = {
  key: 3
};
var _hoisted_22 = {
  class: "body-col col4"
};
var _hoisted_23 = {
  class: "del-col"
};
var _hoisted_24 = {
  key: 0,
  class: "tiny-popupload__dialog-table-list-footer"
};
var _hoisted_25 = {
  key: 0,
  class: "tiny-popupload__dialog-footer"
};
var _hoisted_26 = {
  key: 1,
  class: "tiny-popupload__dialog-footer"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_tiny_button = resolveComponent("tiny-button");
  var _component_tiny_alert = resolveComponent("tiny-alert");
  var _component_tiny_file_upload = resolveComponent("tiny-file-upload");
  var _component_tiny_progress = resolveComponent("tiny-progress");
  var _component_tiny_popconfirm = resolveComponent("tiny-popconfirm");
  var _component_tiny_modal = resolveComponent("tiny-modal");
  return openBlock(), createElementBlock("div", _hoisted_1, [createVNode(_component_tiny_button, {
    size: _ctx.size,
    onClick: _ctx.showDialog,
    disabled: _ctx.state.disabled
  }, {
    default: withCtx(function() {
      return [createTextVNode(
        toDisplayString(_ctx.state.uploadButtonText),
        1
        /* TEXT */
      )];
    }),
    _: 1
    /* STABLE */
  }, 8, ["size", "onClick", "disabled"]), createVNode(_component_tiny_modal, {
    class: "tiny-popupload__modal",
    modelValue: _ctx.state.isShowDialog,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = function($event) {
      return _ctx.state.isShowDialog = $event;
    }),
    title: _ctx.state.dialogTitle,
    width: "648",
    onClose: _ctx.closeDialog
  }, {
    default: withCtx(function() {
      return [createElementVNode("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [renderSlot(_ctx.$slots, "uploadTip"), !_ctx.slots.uploadTip ? (openBlock(), createElementBlock(
        Fragment,
        {
          key: 0
        },
        [_ctx.state.tipsTitle[0] !== void 0 || _ctx.state.tipsTitle[1] !== void 0 || _ctx.state.tipsTitle[2] !== void 0 ? (openBlock(), createBlock(_component_tiny_alert, {
          key: 0,
          size: "large",
          title: _ctx.state.tipsTitleText
        }, {
          default: withCtx(function() {
            return [createElementVNode("div", _hoisted_4, [(openBlock(true), createElementBlock(
              Fragment,
              null,
              renderList(_ctx.state.tipsTitle.filter(function(value) {
                return value !== void 0;
              }), function(item, index) {
                return openBlock(), createElementBlock(
                  "p",
                  {
                    key: index,
                    class: "tiny-popupload__dialog-tips-item"
                  },
                  toDisplayString(item.count !== void 0 ? _ctx.state.limitCountTips + ": " + item.count : "") + " " + toDisplayString(item.type !== void 0 ? _ctx.state.limitTypeTips + ": " + item.type : "") + " " + toDisplayString(item.size !== void 0 ? _ctx.state.limitSizeTips + ": " + item.size : ""),
                  1
                  /* TEXT */
                );
              }),
              128
              /* KEYED_FRAGMENT */
            ))])];
          }),
          _: 1
          /* STABLE */
        }, 8, ["title"])) : createCommentVNode("v-if", true), _ctx.state.errorTips.length > 0 ? (openBlock(), createBlock(_component_tiny_alert, {
          key: 1,
          type: "error",
          size: "large",
          onClose: _ctx.closeErrorTips
        }, {
          default: withCtx(function() {
            return [createElementVNode("div", _hoisted_5, [(openBlock(true), createElementBlock(
              Fragment,
              null,
              renderList(_ctx.state.errorTips, function(item, index) {
                return openBlock(), createElementBlock(
                  "p",
                  {
                    key: index,
                    class: "tiny-popupload__dialog-tips-item"
                  },
                  toDisplayString(item.size !== void 0 ? item.size + ": " + _ctx.state.errorSizeTips : "") + " " + toDisplayString(item.type !== void 0 ? item.type + ": " + _ctx.state.errorTypeTips : "") + " " + toDisplayString(item.num !== void 0 ? _ctx.state.errorNumTips : "") + " " + toDisplayString(item.error !== void 0 ? _ctx.state.uploadErrorTips : ""),
                  1
                  /* TEXT */
                );
              }),
              128
              /* KEYED_FRAGMENT */
            ))])];
          }),
          _: 1
          /* STABLE */
        }, 8, ["onClose"])) : createCommentVNode("v-if", true), _ctx.state.successTips.length > 0 ? (openBlock(), createBlock(_component_tiny_alert, {
          key: 2,
          type: "success",
          size: "large",
          onClose: _ctx.closeSuccessTips
        }, {
          default: withCtx(function() {
            return [createElementVNode("div", _hoisted_6, [(openBlock(true), createElementBlock(
              Fragment,
              null,
              renderList(_ctx.state.successTips, function(item, index) {
                return openBlock(), createElementBlock(
                  "p",
                  {
                    key: index,
                    class: "tiny-popupload__dialog-tips-item"
                  },
                  toDisplayString(item) + "," + toDisplayString(_ctx.state.uploadSuccessTips),
                  1
                  /* TEXT */
                );
              }),
              128
              /* KEYED_FRAGMENT */
            ))])];
          }),
          _: 1
          /* STABLE */
        }, 8, ["onClose"])) : createCommentVNode("v-if", true)],
        64
        /* STABLE_FRAGMENT */
      )) : createCommentVNode("v-if", true)]), createElementVNode("div", _hoisted_7, [createVNode(_component_tiny_file_upload, {
        ref: "upload",
        data: _ctx.data,
        onChange: _ctx.fileUploadChange,
        "http-request": _ctx.httpRequest,
        name: _ctx.uploadName,
        onError: _ctx.errorEvent,
        onExceed: _ctx.handleExceed,
        onProgress: _ctx.progressEvent,
        "before-upload": _ctx.beforeAvatarUpload,
        onSuccess: _ctx.handleAvatarSuccess,
        "with-credentials": _ctx.state.withCredentials,
        multiple: _ctx.state.multiple,
        accept: _ctx.state.accept,
        filters: _ctx.state.filters,
        limit: _ctx.limit,
        headers: _ctx.state.headers,
        action: _ctx.state.action,
        "auto-upload": false,
        "re-uploadable": _ctx.slots.uploadTip
      }, {
        trigger: withCtx(function() {
          return [createVNode(_component_tiny_button, null, {
            default: withCtx(function() {
              return [createTextVNode(
                toDisplayString(_ctx.state.multiple ? _ctx.state.uploadsButtonText : _ctx.state.uploadButtonText),
                1
                /* TEXT */
              )];
            }),
            _: 1
            /* STABLE */
          })];
        }),
        _: 1
        /* STABLE */
      }, 8, ["data", "onChange", "http-request", "name", "onError", "onExceed", "onProgress", "before-upload", "onSuccess", "with-credentials", "multiple", "accept", "filters", "limit", "headers", "action", "re-uploadable"]), createElementVNode("div", _hoisted_8, [createElementVNode("div", _hoisted_9, [createElementVNode(
        "p",
        _hoisted_10,
        toDisplayString(_ctx.state.fileName),
        1
        /* TEXT */
      ), createElementVNode(
        "p",
        _hoisted_11,
        toDisplayString(_ctx.state.fileSize),
        1
        /* TEXT */
      ), createElementVNode(
        "p",
        _hoisted_12,
        toDisplayString(_ctx.state.fileStatus),
        1
        /* TEXT */
      ), createElementVNode(
        "p",
        _hoisted_13,
        toDisplayString(_ctx.state.fileWords.operation),
        1
        /* TEXT */
      )]), createElementVNode("div", _hoisted_14, [createElementVNode("ul", _hoisted_15, [(openBlock(true), createElementBlock(
        Fragment,
        null,
        renderList(_ctx.state.uploadList, function(item, index) {
          return openBlock(), createElementBlock("li", {
            class: "tiny-popupload__dialog-table-item",
            key: index
          }, [createElementVNode(
            "p",
            _hoisted_16,
            toDisplayString(item.name),
            1
            /* TEXT */
          ), createElementVNode(
            "p",
            _hoisted_17,
            toDisplayString(_ctx.formatFileSize(item.size)),
            1
            /* TEXT */
          ), createElementVNode("p", _hoisted_18, [withDirectives(createElementVNode(
            "span",
            {
              class: normalizeClass(["tiny-popupload__status-icon", "tiny-popupload__status-icon-" + item.status])
            },
            null,
            2
            /* CLASS */
          ), [[vShow, item.status !== "uploading"]]), item.status === "ready" ? (openBlock(), createElementBlock(
            "span",
            _hoisted_19,
            toDisplayString(_ctx.state.fileWords.waitUpload),
            1
            /* TEXT */
          )) : item.status === "uploading" ? (openBlock(), createBlock(_component_tiny_progress, {
            key: 1,
            percentage: item.percentage,
            "stroke-width": 4
          }, null, 8, ["percentage"])) : item.status === "success" ? (openBlock(), createElementBlock(
            "span",
            _hoisted_20,
            toDisplayString(_ctx.state.fileWords.success),
            1
            /* TEXT */
          )) : item.status === "fail" ? (openBlock(), createElementBlock(
            "span",
            _hoisted_21,
            toDisplayString(_ctx.state.fileWords.uploadError),
            1
            /* TEXT */
          )) : createCommentVNode("v-if", true)]), createElementVNode("p", _hoisted_22, [createVNode(_component_tiny_popconfirm, {
            title: _ctx.state.fileWords.confirmDeleteTips,
            type: "warning",
            placement: "top-start",
            trigger: "click",
            width: "196",
            "custom-class": "tiny-popupload__pop-confirm",
            onConfirm: function onConfirm($event) {
              return _ctx.deleteFile(item);
            }
          }, {
            reference: withCtx(function() {
              return [createElementVNode(
                "div",
                _hoisted_23,
                toDisplayString(_ctx.state.fileWords.delete),
                1
                /* TEXT */
              )];
            }),
            _: 2
            /* DYNAMIC */
          }, 1032, ["title", "onConfirm"])])]);
        }),
        128
        /* KEYED_FRAGMENT */
      ))]), _ctx.slots.uploadTip ? (openBlock(), createElementBlock("div", _hoisted_24, [createTextVNode(
        toDisplayString(_ctx.t("ui.popupload.listTip", [_ctx.state.uploadList.length])),
        1
        /* TEXT */
      ), withDirectives(createElementVNode(
        "span",
        {
          class: "footer-error-tip"
        },
        toDisplayString(_ctx.t("ui.popupload.errorListTip", [_ctx.state.errorTips.length])),
        513
        /* TEXT, NEED_PATCH */
      ), [[vShow, _ctx.state.errorTips.length > 0]])])) : createCommentVNode("v-if", true)])])]), _ctx.state.theme === "saas" ? (openBlock(), createElementBlock("div", _hoisted_25, [createVNode(_component_tiny_button, {
        onClick: _ctx.closeDialog
      }, {
        default: withCtx(function() {
          return [createTextVNode(
            toDisplayString(_ctx.state.cancelButtonText),
            1
            /* TEXT */
          )];
        }),
        _: 1
        /* STABLE */
      }, 8, ["onClick"]), createVNode(_component_tiny_button, {
        type: "primary",
        disabled: _ctx.state.uploadList.length === 0,
        onClick: _ctx.uploadSubmit
      }, {
        default: withCtx(function() {
          return [createTextVNode(
            toDisplayString(_ctx.state.submitButtonText),
            1
            /* TEXT */
          )];
        }),
        _: 1
        /* STABLE */
      }, 8, ["disabled", "onClick"])])) : (openBlock(), createElementBlock("div", _hoisted_26, [createVNode(_component_tiny_button, {
        type: "primary",
        disabled: _ctx.state.uploadList.length === 0,
        onClick: _ctx.uploadSubmit
      }, {
        default: withCtx(function() {
          return [createTextVNode(
            toDisplayString(_ctx.state.submitButtonText),
            1
            /* TEXT */
          )];
        }),
        _: 1
        /* STABLE */
      }, 8, ["disabled", "onClick"]), createVNode(_component_tiny_button, {
        onClick: _ctx.closeDialog
      }, {
        default: withCtx(function() {
          return [createTextVNode(
            toDisplayString(_ctx.state.cancelButtonText),
            1
            /* TEXT */
          )];
        }),
        _: 1
        /* STABLE */
      }, 8, ["onClick"])]))])];
    }),
    _: 3
    /* FORWARDED */
  }, 8, ["modelValue", "title", "onClose"])]);
}
var pc = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);

export { pc as default };
